package com.jpattern.gwt.client.history;

/**
 * A service to store a fixed number of history steps
 * 
 * @author Francesco Cina
 *
 * 27/lug/2011
 */
public class HistoryService implements IHistoryService {

	private final IHistoryManager historyManager;
	
	public HistoryService() {
		this(new GWTHistoryEngine(), new NullHistoryManagerObserver() );
	}
	
	public HistoryService(IHistoryEngine historyEngine, IHistoryManagerObserver historyManagerObserver) {
		historyManager = new HistoryManager(historyEngine, historyManagerObserver);
	}
	
	@Override
	public IHistoryManager getHistoryManager() {
		return historyManager;
	}

}
