package com.jpattern.gwt.client.navigationevent;

import com.google.gwt.user.client.ui.HasWidgets;

/**
 * 
 * @author Francesco Cina'
 *
 * 08/ago/2011
 */
public class NavigationEventData implements INavigationEventData {

	private final INavigationEvent navigationEvent;
	private final INavigationEventCallback navigationEventCallback;
	private final HasWidgets eventTarget;

	public NavigationEventData(INavigationEvent navigationEvent, HasWidgets eventTarget, INavigationEventCallback navigationEventCallback) {
		this.navigationEvent = navigationEvent;
		this.eventTarget = eventTarget;
		this.navigationEventCallback = navigationEventCallback;
	}

	@Override
	public INavigationEvent getNavigationEvent() {
		return navigationEvent;
	}

	@Override
	public INavigationEventCallback getNavigationEventCallback() {
		return navigationEventCallback;
	}

	@Override
	public HasWidgets getEventTarget() {
		return eventTarget;
	}

}
