package com.jpattern.gwt.client.presenter;

import java.util.List;
import java.util.Map;

import com.google.gwt.user.client.ui.HasWidgets;
import com.jpattern.gwt.client.navigationevent.INavigationEvent;
import com.jpattern.gwt.client.navigationevent.INavigationEventCallback;
import com.jpattern.gwt.client.navigationevent.INavigationEventData;
import com.jpattern.gwt.client.navigationevent.NullNavigationEvent;
import com.jpattern.gwt.client.navigationevent.NullNavigationEventData;
import com.jpattern.gwt.client.view.IView;
import com.jpattern.gwt.client.view.NullView;
import com.jpattern.shared.result.IErrorMessage;

/**
 * 
 * @author Francesco Cina'
 *
 */
public class NullPresenter implements IPresenter {

	@Override
	public void onEventError(List<IErrorMessage> errorMessages) {
	}

	@Override
	public void onEventStart() {
	}

	@Override
	public void render() {
	}
	
	@Override
	public void init() {
	}

	@Override
	public void hierarchy(List<String> hierarchyResult) {
	}

	@Override
	public IView getView() {
		return new NullView();
	}

	@Override
	public void registerNavigationEvent(INavigationEvent navigationEvent, HasWidgets eventTarget, INavigationEventCallback navigationEventCallback) {
		
	}

	@Override
	public INavigationEventData getNavigationEventData(String navigationEventName) {
		return new NullNavigationEventData();
	}

	@Override
	public void launchNavigationEvent(String navigationEventName) {
	}

	@Override
	public INavigationEvent getNavigationEvent() {
		return new NullNavigationEvent();
	}

	@Override
	public void setParent(IPresenter parentPresenter) {
	}

	@Override
	public boolean isInitialized() {
		return false;
	}

	@Override
	public void addInitialNavigationEvent(String navigationEventName) {
	}

	@Override
	public void ignoreInitialEventWithSameTargetOf(String navigationEventName) {
	}

	@Override
	public String getName() {
		return "";
	}

	@Override
	public void addInitialNavigationEvent(String navigationEventName,
			Map<String, String> queryStringValues) {
	}

	@Override
	public void launchNavigationEvent(String navigationEventName,
			Map<String, String> queryStringValues) {
	}

}
